/*
 * TWI_TM1640.c
 *
 * Created: 27.06.2018 20:43:30
 *  Author: 1
 */ 
 #define F_CPU 16000000 //  RC-
 #include <avr/io.h>
 #include <util/delay.h>
 //  SCLK  DIN     
 #define SCLK_DIN_to_output DDRA|=(1<<6)|(1<<7);
 #define SCLK_LOW PORTA&=~(1<<6) //   SCLK
 #define SCLK_HIGH PORTA|=(1<<6) //   SCLK
 #define DIN_LOW PORTA&=~(1<<7) //   DIN
 #define DIN_HIGH PORTA|=(1<<7) //   DIN
 char str[12];//     
 //    0     1     2     3     4     5     6     7     8     9     A     B     C     D     E     F
 char  led[] = {0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F, 0x77, 0x7C, 0x39, 0x5E, 0x79, 0x71};
 //  16-  
 #define A 10
 #define B 11
 #define C 12
 #define D 13
 #define E 14
 #define F 15
 //
 //  
 void TM1640_Message_Start(void)
 {
	 DIN_LOW;
	 SCLK_LOW;
 }
 // 
 void TM1640_Message_Sendbyte(unsigned char byte)
 {
	 // 
	 for(signed char i=0;i<8;i++)
	 {
		 if(byte&(1<<i))DIN_HIGH;//  1
		 else DIN_LOW;//  0
		 SCLK_HIGH;// 
		 SCLK_LOW;// 
		 DIN_LOW;// DIN  "0"		 
	 }
 }
 //  
 void TM1640_Message_Stop(void)
 {
	SCLK_HIGH;
	DIN_HIGH;
 }
 // ,    
 void TM1640_SetPos(char i)
 {
	TM1640_Message_Sendbyte(0b11000000+i);//
 }
 //  
 void TM1640_LED_Bright(char i)
 {
	TM1640_Message_Start(); 
	if(i!=0)TM1640_Message_Sendbyte(0b10001000+i-1);
	else TM1640_Message_Sendbyte(0b10000000); 
	TM1640_Message_Stop();
 }
 //   
 void TM1640_clear(void)
 {
	TM1640_Message_Start();
	TM1640_SetPos(0);
	for(char j=0;j<16;j++)TM1640_Message_Sendbyte(0x00);
	TM1640_Message_Stop(); 
 }
 // 
 int main(void)
 {
	 //    SCLK  DIN 
	 SCLK_DIN_to_output
	 //  SCLK  DIN 
	 SCLK_HIGH;
	 DIN_HIGH; 
	 unsigned char j;// 
	 // 
	 while (1)
	 {
		TM1640_clear();// 
		TM1640_LED_Bright(8);// .  	
		//........  16-   0  F....................
		TM1640_Message_Start();
		TM1640_SetPos(0);
		for(j=0;j<16;j++)
		{
			TM1640_Message_Sendbyte(led[j]);
			_delay_ms(200);
		}
	    TM1640_Message_Stop();	
		//.........   ........................
		for(j=0;j<9;j++)
		{
		TM1640_LED_Bright(8-j);	
		_delay_ms(200);		
		}		
		
	 }
 }